<script setup lang="ts">
const currentGene = useCurrentGene();
const store = useFavoriteGenesStore();

const genes = computed(() => {
  const res = store.favoriteGenes.map((name) => ({
    name,
    url: `/details/${name}`,
    favorite: true,
  }));

  if (currentGene.value === null || store.isFavoriteGene(currentGene.value)) {
    return res;
  } else {
    return [
      {
        name: currentGene.value,
        url: `/details/${currentGene.value}`,
        favorite: false,
      },
      ...res,
    ];
  }
});

const route = useRoute();
const selected = computed(() => {
  return [route.path];
});

const nuxtApp = useNuxtApp();
type Item = {
  title: string;
  url?: string;
  icon?: string;
  external?: boolean;
  children?: Item[];
};

const staticItems: Item[] = [
  {
    title: "Home",
    url: "/",
    icon: "mdi-home-variant-outline",
  },
  {
    title: "My genes",
    url: "/details/",
    icon: "mdi-star-outline",
  },
  {
    title: "Gene ID Conversion",
    url: "/querypipeline/",
    icon: "mdi-timeline-outline",
  },
  {
    title: "Ontology Viewer",
    icon: "mdi-graph-outline",
    children: [
      {
        title: "Ontoscope",
        url: "/ontology/",
      },
      {
        title: "BioPortal",
        url: "http://bioportal.bioontology.org/ontologies/TRON",
        external: true,
      },
    ],
  },
  {
    title: "Genome Browser",
    url: "/genomebrowser/",
    icon: "mdi-chart-timeline",
  },
  {
    title: "Blast",
    icon: "mdi-dna",
    children: [
      {
        title: "iBB Blast",
        url: "/blast/",
      },
      {
        title: "NCBI Blast",
        url: "https://blast.ncbi.nlm.nih.gov/Blast.cgi?PAGE_TYPE=BlastSearch&amp;USER_FORMAT_DEFAULTS=on&amp;SET_SAVED_SEARCH=true&amp;PAGE=MegaBlast&amp;PROGRAM=blastn&amp;GAPCOSTS=0%200&amp;MATCH_SCORES=1%2C-2&amp;BLAST_SPEC=OGP__7070__12539&amp;DATABASE=GPIPE/7070/103/ref_top_level&amp;BLAST_PROGRAMS=megaBlast&amp;MAX_NUM_SEQ=100&amp;SHORT_QUERY_ADJUST=on&amp;EXPECT=10&amp;WORD_SIZE=28&amp;REPEATS=7070&amp;TEMPLATE_TYPE=0&amp;TEMPLATE_LENGTH=0&amp;FILTER=L&amp;FILTER=R&amp;FILTER=m&amp;WWW_BLAST_TYPE=mapview&amp;EQ_MENU=Enter%20organism%20name%20or%20id--completions%20will%20be%20suggested&amp;PROG_DEFAULTS=on&amp;SHOW_OVERVIEW=on&amp;SHOW_LINKOUT=on&amp;ALIGNMENT_VIEW=Pairwise&amp;MASK_CHAR=2&amp;MASK_COLOR=1&amp;GET_SEQUENCE=on&amp;NUM_OVERVIEW=100&amp;DESCRIPTIONS=100&amp;ALIGNMENTS=100&amp;FORMAT_OBJECT=Alignment&amp;FORMAT_TYPE=HTML",
        external: true,
      },
    ],
  },
  {
    title: "API Docs",
    url: `${nuxtApp.$config.public.uiPages.apiDoc}/`,
    icon: "mdi-api",
    external: true,
  },
  {
    title: "Other Resources",
    url: "/resources/",
    icon: "mdi-archive-outline",
  },
  {
    title: "Help",
    url: "/help/",
    icon: "mdi-help-circle-outline",
    children: [
      {
        title: "About",
        url: "/help/about/",
      },
      {
        title: "Data Protection",
        url: "/help/datenschutz/",
      },
      {
        title: "Imprint",
        url: "/help/impressum/",
      },
    ],
  },
];
const { loggedIn } = useOidcAuth();
const items = computed(() => {
  if (loggedIn.value) {
    return [
      ...staticItems,
      {
        title: "Admin",
        url: "/admin/",
        icon: "mdi-shield-account-outline",
      },
    ];
  }
  return staticItems;
});
</script>

<template>
  <v-list
    :selected="selected"
    density="compact"
    color="primary"
    open-strategy="multiple"
    nav
    class="overflow-visible"
  >
    <TransitionGroup name="left-navigator-transition">
      <template
        v-for="{ title, icon, url, external, children } in items"
        :key="title"
      >
        <v-list-group v-if="title === 'My genes'" :value="url">
          <template #activator="{ props: geneDetailsGroupProps }">
            <v-list-item
              v-bind="geneDetailsGroupProps"
              :title="title"
              :prepend-icon="icon"
            />
          </template>
          <LeftNavigatorGeneList :genes="genes" />
        </v-list-group>
        <LeftNavigatorPageItem
          v-else
          :title="title"
          :url="url"
          :icon="icon"
          :external="external"
          :children="children"
        />
      </template>
    </TransitionGroup>
  </v-list>
</template>

<style>
.left-navigator-transition-move {
  transition: all 0.3s ease-in-out;
}
</style>
